---
title: Creating a cross-browser video player
slug: Web/Guide/Audio_and_video_delivery/cross_browser_video_player
tags:
  - Apps
  - HTML5
  - Video
  - full screen
---
<div class="summary">
<p><span class="seoSummary">This article describes a simple HTML5 video player that uses the Media and Fullscreen APIs and works across most major desktop and mobile browsers. As well as working fullscreen, the player features custom controls rather than just using the browser defaults. The player controls themselves won't be styled beyond the basics required to get them working; full styling of the player will be taken care of in a future article.</span></p>
</div>

<h2 id="Working_example">Working example</h2>

<p>Our example video player displays a clip from an open source movie called <a href="http://mango.blender.org/about/">Tears of Steel</a>, and includes typical video controls.</p>

<p><img alt="a shot of a video player, with several control buttons such as play, pause and stop. The video is showing a group of men fighting a group of robots." src="https://mdn.mozillademos.org/files/7319/video-player-example.png" style="display: block; height: 328px; margin: 0px auto; width: 650px;"></p>

<div class="note">
<p><strong>Note</strong>: You can see the <a href="https://iandevlin.github.io/mdn/video-player/">example running live</a>, or check out the <a href="https://github.com/iandevlin/iandevlin.github.io/tree/master/mdn/video-player">source code on Github</a>.</p>
</div>

<h2 id="HTML_Markup">HTML Markup</h2>

<p>To start off with, let's take a look at the HTML that makes up the player.</p>

<h3 id="The_video">The video</h3>

<p>First of all the {{ htmlelement("video") }} element is defined, contained within a {{ htmlelement("figure") }} element that acts as the video container. To anyone familiar with HTML5 markup and the {{ htmlelement("video") }} element, there should be nothing here that surprises you.</p>

<pre class="brush: html">&lt;figure id="videoContainer"&gt;
   &lt;video id="video" controls preload="metadata" poster="img/poster.jpg"&gt;
      &lt;source src="video/tears-of-steel-battle-clip-medium.mp4" type="video/mp4"&gt;
      &lt;source src="video/tears-of-steel-battle-clip-medium.webm" type="video/webm"&gt;
      &lt;source src="video/tears-of-steel-battle-clip-medium.ogg" type="video/ogg"&gt;
      &lt;!-- Flash fallback --&gt;
      &lt;object type="application/x-shockwave-flash" data="flash-player.swf?videoUrl=video/tears-of-steel-battle-clip-medium.mp4" width="1024" height="576"&gt;
         &lt;param name="movie" value="flash-player.swf?videoUrl=video/tears-of-steel-battle-clip-medium.mp4" /&gt;
         &lt;param name="allowfullscreen" value="true" /&gt;
         &lt;param name="wmode" value="transparent" /&gt;
         &lt;param name="flashvars" value="controlbar=over&amp;amp;image=img/poster.jpg&amp;amp;file=flash-player.swf?videoUrl=video/tears-of-steel-battle-clip-medium.mp4" /&gt;
         &lt;img alt="Tears of Steel poster image" src="img/poster.jpg" width="1024" height="428" title="No video playback possible, please download the video from the link below" /&gt;
      &lt;/object&gt;
      &lt;!-- Offer download --&gt;
      &lt;a href="video/tears-of-steel-battle-clip-medium.mp4"&gt;Download MP4&lt;/a&gt;
   &lt;/video&gt;
   &lt;figcaption&gt;&amp;copy; Blender Foundation | &lt;a href="http://mango.blender.org"&gt;mango.blender.org&lt;/a&gt;&lt;/figcaption&gt;
&lt;/figure&gt;</pre>

<p>Even though this player will define its own custom control set, the <code>controls</code> attribute is still added to the {{ htmlelement("video") }} element, and the player's default control set is switched off later with JavaScript. Doing things this way still allows users who have JavaScript turned off (for whatever reason) to still have access to the browser's native controls.</p>

<p>A poster image is defined for the video, and the <code>preload</code> attribute is set to <code>metadata</code>, which informs the browser that it should initially only attempt to load the metadata from the video file rather than the entire video file. This provides the player with data such as video duration and format.</p>

<div class="note">
<p><strong>Note</strong>: IE9 behaves differently than most other browsers when a <code>poster</code> attribute is set. Most browsers interpret the presence of a <code>poster</code> attribute to mean that the specified image is to be displayed until the user chooses to play the video. IE9 will only use the specified poster image in this way if <code>preload="none"</code> is set; otherwise, it will take the first still of the video and display that instead.</p>
</div>

<p>Three different video sources are provided for the player: MP4, WebM, and Ogg. Using these different source formats gives the best chance of being supported across all browsers that support HTML5 video. For further information on video formats and browser compatibility, see <a href="/en-US/docs/HTML/Supported_media_formats#Browser_compatibility">supported media formats</a>.</p>

<p>For browsers that do not support HTML5 video, a Flash player is provided that will allow playback of the MP4 video source, provided the end user has Flash installed. In addition a download link is displayed to allow users to download the MP4 video file, should they wish to (providing those without Flash installed with a method of viewing the video, a fallback for a fallback if you like).</p>

<p>The code above would allow playback of the video in most browsers, using the browser's default control set. The next step is to define a custom control set, also in HTML, which will be used to control the video.</p>

<h3 id="The_control_set">The control set</h3>

<p>Most browser's default video controls have the following functionality:</p>

<ul>
 <li>Play/pause</li>
 <li>Mute</li>
 <li>Volume control</li>
 <li>Progress bar</li>
 <li>Skip ahead</li>
 <li>Go fullscreen</li>
</ul>

<p>The custom control set will also support this functionality, with the addition of a stop button.</p>

<p>Once again the HTML is quite straightforward, using an unordered list with <code>list-style-type:none</code> set to enclose the controls, each of which is a list item with <code>float:left</code>. For the progress bar, the <code>progress</code> element is taken advantage of, with a fallback provided for browsers that don't support it (e.g. IE8 and IE9). This list is inserted after the {{ htmlelement("video") }} element, but inside the {{ htmlelement("figure") }} element (this is important for the fullscreen functionality, which is explained later on).</p>

<pre class="brush: html">&lt;ul id="video-controls" class="controls"&gt;
   &lt;li&gt;&lt;button id="playpause" type="button"&gt;Play/Pause&lt;/button&gt;&lt;/li&gt;
   &lt;li&gt;&lt;button id="stop" type="button"&gt;Stop&lt;/button&gt;&lt;/li&gt;
   &lt;li class="progress"&gt;
      &lt;progress id="progress" value="0" min="0"&gt;
         &lt;span id="progress-bar"&gt;&lt;/span&gt;
      &lt;/progress&gt;
   &lt;/li&gt;
   &lt;li&gt;&lt;button id="mute" type="button"&gt;Mute/Unmute&lt;/button&gt;&lt;/li&gt;
   &lt;li&gt;&lt;button id="volinc" type="button"&gt;Vol+&lt;/button&gt;&lt;/li&gt;
   &lt;li&gt;&lt;button id="voldec" type="button"&gt;Vol-&lt;/button&gt;&lt;/li&gt;
   &lt;li&gt;&lt;button id="fs" type="button"&gt;Fullscreen&lt;/button&gt;&lt;/li&gt;
&lt;/ul&gt;
</pre>

<p>Each button is given an <code>id</code> so it can be easily accessed with JavaScript. The <code>span</code> within the {{ htmlelement("progress") }} element is for <a href="http://caniuse.com/#search=progress">browsers that do not support the <code>progress</code> element</a> and will be updated at the same time as <code>progress</code> (this <code>span</code> element won't be visible on browsers that support <code>progress</code>).</p>

<p>The controls are initially hidden with a CSS <code>display:none</code> and will be enabled with JavaScript. Again if a user has JavaScript disabled, the custom control set will not appear and they can use the browser's default control set unhindered.</p>

<p>Of course this custom control set is currently useless and doesn't do a thing: Let's improve the situation with JavaScript.</p>

<h2 id="Using_the_Media_API">Using the Media API</h2>

<p>HTML5 comes with a JavaScript <a href="https://developer.mozilla.org/en/docs/Web/API/HTMLMediaElement">Media API</a> that allows developers access to and control of HTML5 media. This API will be used to make the custom control set defined above actually do something. In addition, the fullscreen button will use the <a href="/en-US/docs/Web/Guide/API/DOM/Using_full_screen_mode">Fullscreen API</a>, another W3C API that controls the ability of web browsers to show apps using your computer's full screen.</p>

<h3 id="Setup">Setup</h3>

<p>Before dealing with the individual buttons, a number of initialisation calls are required.</p>

<p>To begin with, it's a good idea to first check if the browser actually supports the {{ htmlelement("video") }} element and to only setup the custom controls if it does. This is done by checking if a created {{ htmlelement("video") }} element supports <a href="http://www.w3.org/html/wg/drafts/html/master/embedded-content.html#dom-navigator-canplaytype">the <code>canPlayType()</code> method</a>, which any supported HTML5 {{ htmlelement("video") }} element should.</p>

<pre class="brush: js">var supportsVideo = !!document.createElement('video').canPlayType;
if (supportsVideo) {
   // set up custom controls
   // ...
}
</pre>

<p>Once it has been confirmed that the browser does indeed support HTML5 video, it's time to set up the custom controls. A number of variables pointing to HTML elements are required:</p>

<pre class="brush: js">var videoContainer = document.getElementById('videoContainer');
var video = document.getElementById('video');
var videoControls = document.getElementById('video-controls');
</pre>

<p>As mentioned earlier, the browser's default controls now need to be disabled, and the custom controls need to be displayed:</p>

<pre class="brush: js">// Hide the default controls
video.controls = false;

// Display the user defined video controls
videoControls.style.display = 'block';
</pre>

<p>With that done, a variable pointing to each of the buttons is now required:</p>

<pre class="brush: js">var playpause = document.getElementById('playpause');
var stop = document.getElementById('stop');
var mute = document.getElementById('mute');
var volinc = document.getElementById('volinc');
var voldec = document.getElementById('voldec');
var progress = document.getElementById('progress');
var progressBar = document.getElementById('progress-bar');
var fullscreen = document.getElementById('fs');
</pre>

<p>Using these handles, events can now be attached to each of the custom control buttons making them interactive. Most of these buttons require a simple <code>click</code> event listener to be added, and a Media API defined method and/or attributes to be called/checked on the video.</p>

<h3 id="PlayPause">Play/Pause</h3>

<pre class="brush: js">playpause.addEventListener('click', function(e) {
   if (video.paused || video.ended) video.play();
   else video.pause();
});
</pre>

<p>When a <code>click</code> event is detected on the play/pause button, the handler first of all checks if the video is currently paused or has ended (via the Media API's <code>paused</code> and <code>ended</code> attributes); if so, it uses the <code>play()</code> method to playback the video. Otherwise the video must be playing, so it is paused using the <code>pause()</code> method.</p>

<h3 id="Stop">Stop</h3>

<pre class="brush: js">stop.addEventListener('click', function(e) {
   video.pause();
   video.currentTime = 0;
   progress.value = 0;
});
</pre>

<p>The Media API doesn't have a <code>stop</code> method, so to mimic this the video is paused, and its <code>currentTime</code> (i.e. the video's current playing position) and the {{ htmlelement("progress") }} element's position is set to 0 (more on the {{ htmlelement("progress") }} element later).</p>

<h3 id="Mute">Mute</h3>

<pre class="brush: js">mute.addEventListener('click', function(e) {
   video.muted = !video.muted;
});
</pre>

<p>The mute button is a simple toggle button that uses the Media API's <code>muted</code> attribute to mute the video: this is a Boolean indicating whether the video is muted or not. To get it to toggle, we set it to the inverse of itself.</p>

<h3 id="Volume">Volume</h3>

<pre class="brush: js">volinc.addEventListener('click', function(e) {
   alterVolume('+');
});
voldec.addEventListener('click', function(e) {
   alterVolume('-');
});
</pre>

<p>Two volume control buttons have been defined, one for increasing the volume and another for decreasing it. A user defined function, <code>alterVolume(direction)</code> has been created that deals with this:</p>

<pre class="brush: js">var alterVolume = function(dir) {
   var currentVolume = Math.floor(video.volume * 10) / 10;
   if (dir === '+') {
      if (currentVolume &lt; 1) video.volume += 0.1;
   }
   else if (dir === '-') {
      if (currentVolume &gt; 0) video.volume -= 0.1;
   }
}
</pre>

<p>This function makes use of the Media API's <code>volume</code> attribute, which holds the current volume value of the video. Valid values for this attribute are 0 and 1 and anything in between. The function checks the <code>dir</code> parameter, which indicates whether the volume is to be increased (+) or decreased (-) and acts accordingly. The function is defined to increase or decrease the video's <code>volume</code> attribute in steps of 0.1, ensuring that it doesn't go lower than 0 or higher than 1.</p>

<h3 id="Progress">Progress</h3>

<p>When the {{ htmlelement("progress") }} element was defined above in the HTML, only two attributes were set, <code>value</code> and <code>min</code>, both being given a value of 0. The function of these attributes is self-explanatory, with <code>min</code> indicating the minimum allowed value of the <code>progress</code> element and <code>value</code> indicating its current value. It also needs to have a maximum value set so that it can display its range correctly, and this can be done via the <code>max</code> attribute, which needs to be set to the maximum playing time of the video. This is obtained from the video's <code>duration</code> attribute, which again is part of the Media API.</p>

<p>Ideally, the correct value of the video's <code>duration</code> attribute is available when the <code>loadedmetadata</code> event is raised, which occurs when the video's metadata has been loaded:</p>

<pre class="brush: js">video.addEventListener('loadedmetadata', function() {
   progress.setAttribute('max', video.duration);
});
</pre>

<p>Unfortunately in some mobile browsers, when <code>loadedmetadata</code> is raised — if it even <em>is</em> raised — <code>video.duration</code> may not have the correct value, or even any value at all. So something else needs to be done. More on that below.</p>

<p>Another event, <code>timeupdate</code>, is raised periodically as the video is being played through. This event is ideal for updating the progress bar's value, setting it to the value of the video's <code>currentTime</code> attribute, which indicates how far through the video the current playback is.</p>

<pre class="brush: js">video.addEventListener('timeupdate', function() {
   progress.value = video.currentTime;
   progressBar.style.width = Math.floor((video.currentTime / video.duration) * 100) + '%';
});
</pre>

<p>As the <code>timeupdate</code> event is raised, the <code>progress</code> element's <code>value</code> attribute is set to the video's <code>currentTime</code>. The {{ htmlelement("span") }} element mentioned earlier, for browsers that do not support the {{ htmlelement("progress") }} element (e.g. Internet Explorer 9), is also updated at this time, setting its width to be a percentage of the total time played. This span has a solid CSS background colour, which helps it provide the same visual feedback as a {{ htmlelement("progress") }} element.</p>

<p>Coming back to the <code>video.duration</code> problem mentioned above, when the <code>timeupdate</code> event is raised, in most mobile browsers the video's <code>duration</code> attribute should now have the correct value. This can be taken advantage of to set the <code>progress</code> element's <code>max</code> attribute if it is currently not set:</p>

<pre class="brush: js">video.addEventListener('timeupdate', function() {
   if (!progress.getAttribute('max')) progress.setAttribute('max', video.duration);
   progress.value = video.currentTime;
   progressBar.style.width = Math.floor((video.currentTime / video.duration) * 100) + '%';
});
</pre>

<div class="note">
<p><strong>Note</strong>: for more information and ideas on progress bars and buffering feedback, read <a href="/en-US/Apps/Build/Manipulating_media/buffering_seeking_time_ranges">Media buffering, seeking, and time ranges</a>.</p>
</div>

<h3 id="Skip_Ahead">Skip Ahead</h3>

<p>Another feature of most browser default video control sets is the ability to click on the video's progress bar to "skip ahead" to a different point in the video. This can also be achieved by adding a simple <code>click</code> event listener to the <code>progress</code> element:</p>

<pre class="brush: js">progress.addEventListener('click', function(e) {
   var pos = (e.pageX  - this.offsetLeft) / this.offsetWidth;
   video.currentTime = pos * video.duration;
});
</pre>

<p>This piece of code uses the clicked position to (roughly) work out where in the <code>progress</code> element the user has clicked, and to move the video to that position by setting its <code>currentTime</code> attribute.</p>

<h3 id="Fullscreen">Fullscreen</h3>

<p>The Fullscreen API should be straight forward to use: the user clicks a button, if the video is in fullscreen mode: cancel it, otherwise enter fullscreen mode.</p>

<p>Alas it has been implemented in browsers in a number of weird and wonderful ways which requires a lot of extra code to check for various prefixed versions of attributes and methods so as to call the right one.</p>

<p>To detect if a browser actually supports the Fullscreen API and that it is enabled, the following may be called:</p>

<pre class="brush: js">var fullScreenEnabled = !!(document.fullscreenEnabled || document.mozFullScreenEnabled || document.msFullscreenEnabled || document.webkitSupportsFullscreen || document.webkitFullscreenEnabled || document.createElement('video').webkitRequestFullScreen);
</pre>

<p>This tests all the different prefixed (and of course the non-prefixed!) booleans to see if fullscreen is possible. The final tested value, <code>document.createElement('video').webkitRequestFullScreen</code> is required for the last Presto version of Opera (12.14). Note the different letter casing in the various values.</p>

<p>The visibility of the fullscreen button depends on whether the browser supports the Fullscreen API and that it is enabled:</p>

<pre class="brush: js">if (!fullScreenEnabled) {
   fullscreen.style.display = 'none';
}
</pre>

<p>Naturally the fullscreen button needs to actually do something, so, like the other buttons, a <code>click</code> event handler is attached in which we call a user defined function <code>handleFullscreen</code>:</p>

<pre class="brush: js">fullscreen.addEventListener('click', function(e) {
   handleFullscreen();
});
</pre>

<p>The <code>handleFullscreen</code> function is defined as follows:</p>

<pre class="brush: js">var handleFullscreen = function() {
   if (isFullScreen()) {
      if (document.exitFullscreen) document.exitFullscreen();
      else if (document.mozCancelFullScreen) document.mozCancelFullScreen();
      else if (document.webkitCancelFullScreen) document.webkitCancelFullScreen();
      else if (document.msExitFullscreen) document.msExitFullscreen();
      setFullscreenData(false);
   }
   else {
      if (videoContainer.requestFullscreen) videoContainer.requestFullscreen();
      else if (videoContainer.mozRequestFullScreen) videoContainer.mozRequestFullScreen();
      else if (videoContainer.webkitRequestFullScreen) videoContainer.webkitRequestFullScreen();
      else if (videoContainer.msRequestFullscreen) videoContainer.msRequestFullscreen();
      setFullscreenData(true);
   }
}
</pre>

<p>First of all the function checks if the browser is already in fullscreen mode by calling another function <code>isFullScreen</code>:</p>

<pre class="brush: js">var isFullScreen = function() {
   return !!(document.fullscreen || document.webkitIsFullScreen || document.mozFullScreen || document.msFullscreenElement || document.fullscreenElement);
}
</pre>

<p>This function checks all the various browser prefixed versions to try and determine the correct result.</p>

<p>If the browser is currently in fullscreen mode, then it must be exited and vice versa. Support for the different prefixed versions of the relevant action are checked in order to call the correct one. Interestingly <code>document</code> must be used for exiting/cancelling fullscreen mode, whereas any HTML element can request fullscreen mode, here the <code>videoContainer</code> is used as it also contains the custom controls which should also appear with the video in fullscreen mode.</p>

<p>The exception to this is Safari 5.1, which will only allow <code>webkitRequestFullScreen</code> to be called on the {{ htmlelement("video") }} element. The custom controls will only appear on this browser in fullscreen mode with some WebKit specific CSS:</p>

<ol>
 <li>The default browser controls have to be hidden with <code>video::-webkit-media-controls { display:none !important; }</code></li>
 <li>The custom controls container needs to have a special <code>z-index</code> value: <code>.controls { z-index:2147483647; }</code></li>
</ol>

<p>Dealing with WebKit-specific code in this way will affect all WebKit browsers, but everything works as expected in more advanced WebKit browsers such as Chrome and the latest Opera.</p>

<p>Another user defined function — <code>setFullscreenData()</code> — is also called, which sets the value of a <code>data-fullscreen</code> attribute on the <code>videoContainer</code> (this makes use of <a href="http://toddmotto.com/stop-toggling-classes-with-js-use-behaviour-driven-dom-manipulation-with-data-states/"><code>data-states</code></a>).</p>

<pre class="brush: js">var setFullscreenData = function(state) {
   videoContainer.setAttribute('data-fullscreen', !!state);
}
</pre>

<p>This is used to set some basic CSS to improve the styling of the custom controls when they are in fullscreen (see the sample code for further details). When a video goes into fullscreen mode, it usually displays a message indicating that the user can press the <em>Esc</em> key to exit fullscreen mode, so the code also needs to listen for relevant events in order to call the <code>setFullscreenData()</code> function to ensure the control styling is correct:</p>

<pre class="brush: js">document.addEventListener('fullscreenchange', function(e) {
   setFullscreenData(!!(document.fullscreen || document.fullscreenElement));
});
document.addEventListener('webkitfullscreenchange', function() {
   setFullscreenData(!!document.webkitIsFullScreen);
});
document.addEventListener('mozfullscreenchange', function() {
   setFullscreenData(!!document.mozFullScreen);
});
document.addEventListener('msfullscreenchange', function() {
   setFullscreenData(!!document.msFullscreenElement);
});
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{ htmlelement("video") }} for reference material</li>
 <li><a href="/en-US/docs/Web/Guide/HTML/Using_HTML5_audio_and_video">Using HTML5 audio and video</a> for more techniques</li>
 <li><a href="/en-US/docs/HTML/Supported_media_formats">Media formats supported by the HTML audio and video elements</a></li>
 <li><a href="http://camendesign.com/code/video_for_everybody">Video for Everybody</a>: written by Kroc Camen, this is quite old, but still has some good relevant content and is a great starter article for cross-browser HTML5 video.</li>
</ul>
